/**Rappresenta un host sul quale poter eseguire un interprete remoto via ssh.
 * ha come attributi i dati necessari al login ssh.
 * */
public class Host {

	/**porta di default (22 per ssh)*/
	private static int DEFAULT_PORT = 22; //22 ssh default port
	
	private String username;
	private String hostname;
	private String password;
	private int sshPort;
	
	/**
	 * Costruisce un nuovo Host
	 * @param hostname L'hostname dell'host
	 * @param username L'username con il quale è possibile loggarsi sull'host
	 * @param password La password dell'utente
	 * @param sshPort La porta alla quale connettersi per loggarsi al host
	 * */
	public Host(String username, String hostname, String password, int sshPort) {
		
		this.hostname = hostname;
		this.username = username;
		this.password = password;
		this.sshPort = sshPort;
	}
	
	/**
	 * Costruisce un nuovo Host usando la porta di default
	 * @param hostname L'hostname dell'host
	 * @param username L'username con il quale è possibile loggarsi sull'host
	 * @param password La password dell'utente
	 * */
	public Host(String username,String hostname, String password) {
		
		this(username, hostname, password, DEFAULT_PORT);
	}

	public String getHostname() {
		return hostname;
	}

	public String getUsername() {
		return username;
	}

	public String getPassword() {
		return password;
	}

	public int getSshPort() {
		return sshPort;
	}
	
	public String toString(){
		
		return username+"@"+hostname+":"+sshPort+" "+password;
	}
	
}
