package examples;
/* This is the muskel: a skeleton/RMI based, parallel programming library
Copyright (C) 2006  Marco Danelutto, Dept. Computer Science, Univ. Pisa, Italy

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */

import muskel.mdf.Task;
import skeleton.Compute;

/**
 * Prende un Integer e lo incrementa. Usato a scopo di test.
 * E' incluso un delay loop per dimostrare i timings.
 * @author Danelutto Marco
 *
 */
public class Inc extends Compute {

	private static final long serialVersionUID = 8291468701762043559L;

	@Override
	public Task[] compute(Task[] task) {

		Integer xI = (Integer) task[0].getValue();
		
		int x = xI.intValue();
		double y = (double) x;
		for(int i=0;i<2000000;i++) 
			y = Math.sin(y);
		
		System.out.println("INC : computes "+x+" ("+y+")");
		
		Task[] toReturn = {new Task(new Integer(++x))};
		
		return toReturn;
	}
}
