package examples;

import map.MapCollector;
import map.MapEmitter;
import muskel.*;
import muskel.mdf.*;
import skeleton.*;

/**
 * Codice muskel di una Map con 8 workers, generato da IMuskelGUI.
 * */
public class Map8 extends ParCompute {

	public Map8(Manager manager) {

		super(null);

		/* please use your favourite id generator */
		IdGenerator idGen = new IntegerIdGenerator();

		InstructionId i1_Id = new InstructionId(idGen.generateId());
		InstructionId i2_Id = new InstructionId(idGen.generateId());
		InstructionId i3_Id = new InstructionId(idGen.generateId());
		InstructionId i4_Id = new InstructionId(idGen.generateId());
		InstructionId i5_Id = new InstructionId(idGen.generateId());
		InstructionId i6_Id = new InstructionId(idGen.generateId());
		InstructionId i7_Id = new InstructionId(idGen.generateId());
		InstructionId i8_Id = new InstructionId(idGen.generateId());
		InstructionId i9_Id = new InstructionId(idGen.generateId());
		InstructionId i10_Id = new InstructionId(idGen.generateId());

		/*MDFi n.1 setup*/
		Destination[] dests_1 = new Destination[8];

		Destination d0_1 = new Destination(new InputPositionId(new IntegerIdentifier(0)), i2_Id, Mdfi.NoGraphId);
		dests_1[0] = d0_1;

		Destination d1_1 = new Destination(new InputPositionId(new IntegerIdentifier(0)), i3_Id, Mdfi.NoGraphId);
		dests_1[1] = d1_1;

		Destination d2_1 = new Destination(new InputPositionId(new IntegerIdentifier(0)), i4_Id, Mdfi.NoGraphId);
		dests_1[2] = d2_1;

		Destination d3_1 = new Destination(new InputPositionId(new IntegerIdentifier(0)), i5_Id, Mdfi.NoGraphId);
		dests_1[3] = d3_1;

		Destination d4_1 = new Destination(new InputPositionId(new IntegerIdentifier(0)), i6_Id, Mdfi.NoGraphId);
		dests_1[4] = d4_1;

		Destination d5_1 = new Destination(new InputPositionId(new IntegerIdentifier(0)), i7_Id, Mdfi.NoGraphId);
		dests_1[5] = d5_1;

		Destination d6_1 = new Destination(new InputPositionId(new IntegerIdentifier(0)), i8_Id, Mdfi.NoGraphId);
		dests_1[6] = d6_1;

		Destination d7_1 = new Destination(new InputPositionId(new IntegerIdentifier(0)), i9_Id, Mdfi.NoGraphId);
		dests_1[7] = d7_1;

		Mdfi i1 = new Mdfi(manager, i1_Id, new MapEmitter(), 1, 8, dests_1);

		/*MDFi n.2 setup*/
		Destination[] dests_2 = new Destination[1];

		Destination d0_2 = new Destination(new InputPositionId(new IntegerIdentifier(0)), i10_Id, Mdfi.NoGraphId);
		dests_2[0] = d0_2;

		Mdfi i2 = new Mdfi(manager, i2_Id, new Square(), 1, 1, dests_2);

		/*MDFi n.3 setup*/
		Destination[] dests_3 = new Destination[1];

		Destination d0_3 = new Destination(new InputPositionId(new IntegerIdentifier(1)), i10_Id, Mdfi.NoGraphId);
		dests_3[0] = d0_3;

		Mdfi i3 = new Mdfi(manager, i3_Id, new Square(), 1, 1, dests_3);

		/*MDFi n.4 setup*/
		Destination[] dests_4 = new Destination[1];

		Destination d0_4 = new Destination(new InputPositionId(new IntegerIdentifier(2)), i10_Id, Mdfi.NoGraphId);
		dests_4[0] = d0_4;

		Mdfi i4 = new Mdfi(manager, i4_Id, new Square(), 1, 1, dests_4);

		/*MDFi n.5 setup*/
		Destination[] dests_5 = new Destination[1];

		Destination d0_5 = new Destination(new InputPositionId(new IntegerIdentifier(3)), i10_Id, Mdfi.NoGraphId);
		dests_5[0] = d0_5;

		Mdfi i5 = new Mdfi(manager, i5_Id, new Square(), 1, 1, dests_5);

		/*MDFi n.6 setup*/
		Destination[] dests_6 = new Destination[1];

		Destination d0_6 = new Destination(new InputPositionId(new IntegerIdentifier(4)), i10_Id, Mdfi.NoGraphId);
		dests_6[0] = d0_6;

		Mdfi i6 = new Mdfi(manager, i6_Id, new Square(), 1, 1, dests_6);

		/*MDFi n.7 setup*/
		Destination[] dests_7 = new Destination[1];

		Destination d0_7 = new Destination(new InputPositionId(new IntegerIdentifier(5)), i10_Id, Mdfi.NoGraphId);
		dests_7[0] = d0_7;

		Mdfi i7 = new Mdfi(manager, i7_Id, new Square(), 1, 1, dests_7);

		/*MDFi n.8 setup*/
		Destination[] dests_8 = new Destination[1];

		Destination d0_8 = new Destination(new InputPositionId(new IntegerIdentifier(6)), i10_Id, Mdfi.NoGraphId);
		dests_8[0] = d0_8;

		Mdfi i8 = new Mdfi(manager, i8_Id, new Square(), 1, 1, dests_8);

		/*MDFi n.9 setup*/
		Destination[] dests_9 = new Destination[1];

		Destination d0_9 = new Destination(new InputPositionId(new IntegerIdentifier(7)), i10_Id, Mdfi.NoGraphId);
		dests_9[0] = d0_9;

		Mdfi i9 = new Mdfi(manager, i9_Id, new Square(), 1, 1, dests_9);

		/*MDFi n.10 setup*/
		Destination d0_10 = new Destination(new InputPositionId(new IntegerIdentifier(0)), Mdfi.NoInstrId, Mdfi.NoGraphId);
		Destination[] dests_10 = {d0_10};

		Mdfi i10 = new Mdfi(manager, i10_Id, new MapCollector(), 8, 1, dests_10);

		/*MDF graph setup*/
		program = new MdfGraph();

		program.addInstruction(i1);
		program.addInstruction(i2);
		program.addInstruction(i3);
		program.addInstruction(i4);
		program.addInstruction(i5);
		program.addInstruction(i6);
		program.addInstruction(i7);
		program.addInstruction(i8);
		program.addInstruction(i9);
		program.addInstruction(i10);
		program.setInputInstruction(i1);
		program.setOutputInstruction(i10);

	}

}

