package examples;
/* This is the muskel: a skeleton/RMI based, parallel programming library
Copyright (C) 2006  Marco Danelutto, Dept. Computer Science, Univ. Pisa, Italy

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */

import muskel.mdf.Task;
import skeleton.SECompute;

/**
 * Questo e' una funzione Compute che calcola il quadrato di un numero. 
 * Il delay loop è stato aggiunto per dimostrare i timings.
 * 
 * Genera come effetto collaterale un task se l'input è pari.
 * 
 * @author marcod
 * @author albanese
 *
 */
 public class SESquare extends SECompute {

	private static final long serialVersionUID = 2295172192703176107L;

	/** 
	  * Implements a simple worker calculating the square of an Integer
	  */
	 public Task[] compute(Task[] task) {
		 
		 int numIter = 2000000;//2M
		 
		 int x = (Integer) task[0].getValue();
		 double y = (double) x;
		 
		 //delay loop
		 for(int i=0; i<numIter; i++) 
			 y = Math.sin(y);
		 
		 //se x e' pari genero un nuovo task dispari
		 if (x % 2 == 0) {
			 int newTask = x-1;
			 System.out.println("New task generated: "+(newTask) +" from task "+x);
			 setGeneratedTask(new Task[]{new Task(new Integer(newTask))});
		 }
			 	 
		 int square = x*x;
		 
		 Task[] toReturn = {new Task(new Integer(square))};
		 
		 System.out.println("SESquare("+x+"): "+(square));
		 
		 return toReturn;
	 }
}
