package examples;
/* This is the muskel: a skeleton/RMI based, parallel programming library
Copyright (C) 2006  Marco Danelutto, Dept. Computer Science, Univ. Pisa, Italy

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */

import skeleton.Compute;
import skeleton.Farm;
import skeleton.Pipeline;
import muskel.*;
import muskel.stream.ConsoleOutputManager;
import muskel.stream.InputManager;
import muskel.stream.IntegerStreamInputManager;
import muskel.stream.OutputManager;

/**
 * Codice di esempio per creare una applicazione parallela
 * usando muskel.
 * 
 * @author marcod
 *
 */

public class SampleCode {

	public static void main(String[] args) {
		int parDegree;
		try { parDegree = Integer.parseInt(args[0]);
 		} catch(ArrayIndexOutOfBoundsException e) { parDegree = 1; }

		Compute inc1 = new Inc();
		Compute sq1 = new Square();
		Compute f1 = new Farm(sq1);
		Compute main = new Pipeline(inc1,f1);

		InputManager sampleISM = 
			(InputManager) new IntegerStreamInputManager(10);
		OutputManager sampleOSM = 
			(OutputManager) new ConsoleOutputManager();
		
		Manager manager = new Manager(main, sampleISM, sampleOSM);
		manager.setContract(new ParDegree(parDegree));
		
		manager.compute();
	}

}
