package examples;
/* This is the muskel: a skeleton/RMI based, parallel programming library
Copyright (C) 2006  Marco Danelutto, Dept. Computer Science, Univ. Pisa, Italy

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */

import muskel.mdf.Task;
import skeleton.Compute;

/**
 * This is a compute function computing the square of a number. 
 * A delay loop is included for demonstrating timings.
 * 
 * @author marcod
 *
 */
 public class Square extends Compute {

	private static final long serialVersionUID = 4244043631856051889L;

	/** 
	  * Implements a simple worker calculating the square of an Integer
	  */
	 public Task[] compute(Task[] task) {
		 
		 int numIter = 50000000;//50M
		 
		 int x = (Integer) task[0].getValue();
		 double y = (double) x;
		 
		 //delay loop
		 for(int i=0; i<numIter; i++) 
			 y = Math.sin(y);
		 	 
		 int square = x*x;
		 
		 System.out.println("Square("+x+"): "+(square));
		 Task[] toReturn = {new Task(new Integer(square))};
		 
		 return toReturn;
	 }
}
