package map;

import java.util.Vector;
import muskel.mdf.Task;
import skeleton.Compute;

/**
 * Semplice collector per implementare una Map.
 * */
public class MapCollector extends Compute {

	private static final long serialVersionUID = -3656835617041306069L;
	
	/**
	 * Restituisce un Task[] avente come unico elemento un Vector
	 * contenente gli elementi di <code>task</code>.
	 * @param task I task da raccogliere in un unico Vector
	 * */
	@SuppressWarnings("unchecked")
	@Override
	public Task[] compute(Task[] task) {
	
		Vector v = new Vector(task.length);
		
		//collect the results
		for (Task t: task)
			v.add(t.getValue());
	
		//create the output
		Task[] toReturn = {new Task(v)};
				
		return toReturn;
	}
}
