package map;

import java.util.Vector;
import muskel.mdf.Task;
import skeleton.Compute;

/**
 * Semplice emitter per implementare una Map.
 * */
public class MapEmitter extends Compute {

	private static final long serialVersionUID = 7824884734899083241L;
		
	/**
	 * Restituisce un Task[] avente come elementi, i corrispettivi
	 * elementi del vettore contenuto in <code>task[0]</code>
	 * (il primo elemento dell'array Task passato come parametro)
	 * <code>task[0]</code> deve essere un Vector di lunghezza
	 * <code>n</code> (specificato alla creazione).
	 * @param task array avente come primo (e unico) elemento un Vector
	 * @throws IllegalArgumentException se task[0] non e' un Vector
	 * */
	@SuppressWarnings("unchecked")
	@Override
	public Task[] compute(Task[] task) {
				
		Object o = task[0].getValue();
		
		Vector t;
		
		if (o instanceof Vector)
			t = (Vector) o;
		else throw new IllegalArgumentException();
		
		Task[] toReturn = new Task[t.size()];
				
		for(int i = 0; i < t.size(); i++)
			toReturn[i] = new Task(t.elementAt(i));
		
		return toReturn;
	}

}
