/* This is the muskel: a skeleton/RMI based, parallel programming library
Copyright (C) 2006  Marco Danelutto, Dept. Computer Science, Univ. Pisa, Italy

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */

/*
 * Created on Oct 21, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package muskel;

/**
 * This is a contract that can be issued to a manager,
 * specifying the amount of processing elements that have
 * to be used to implement the manager controlled computation. 
 * 
 * @author marcod
 *
 */
public class ParDegree implements Contract {
	
	/** this is the actual parallelism degree wanted for this contract 
	 * 
	 */
	private int pardegree = 1;
	
	/**
	 * constructor: sets up the initial value of the contract
	 * @param nw the parallelism degree to be sustained by this contract
	 */
	public ParDegree(int nw) {
		pardegree = nw;
	}
	
	/** 
	 * allows the current implementation of the contract to be inspected
	 * @return the current parallelism degree
	 */
	public int getParDegree() {
		return pardegree;
	}
	/**
	 * sets the parallelism degree. Used to change the value
	 * @param nw the new vaule of the parallelism degree
	 * TODO va registrato un handler per avvertire il
	 * manager di un cambiamento nel contratto.
	 * occorre anche definirne il tipo ... 
	 */
	public void setParDegree(int nw) {
		pardegree = nw;
	}
}
