/* This is the muskel: a skeleton/RMI based, parallel programming library
Copyright (C) 2006  Marco Danelutto, Dept. Computer Science, Univ. Pisa, Italy

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */

package muskel;

import skeleton.Compute;
import skeleton.Farm;
import skeleton.Pipeline;

public class PrettyPrint {

	Compute program = null; 
	
	public PrettyPrint(Compute pgm) {
		program = pgm;
	}
	
	public String toString() {
		String result = "";
		if(program instanceof Farm) {
			Compute worker = ((Farm) program).getWorker();
			String workerString = (new PrettyPrint(worker)).toString();
			result = " Farm("+workerString+" )";
			return result;
		}
		if(program instanceof Pipeline) {
			Compute stage1 = ((Pipeline) program).getFirstStage();
			Compute stage2 = ((Pipeline) program).getSecondStage();
			String stage1String = (new PrettyPrint(stage1)).toString();
			String stage2String = (new PrettyPrint(stage2)).toString();
			return ("("+stage1String+ " | "+ stage2String+")");
		}
		return (" "+program.toString()+" ");
	}
}
