package muskel.mdf;

import java.io.Serializable;

/**
 * Generic Mdfi Id superclass
 * */
public class GenericId implements Cloneable, Serializable {

	private static final long serialVersionUID = -4895486775094105801L;
	
	protected Identifier id;
	
	public GenericId(Identifier id) {
		this.id = id;
	}

	/** Getter */
	public Identifier getId() {
		return id;
	}

	@Override
	public String toString()
	{
		return id.toString();
	}
	
	/**
	 * shallow copy perche' Identifier e' immutabile
	 * */
	@Override
	public Object clone() {
		
		return new GenericId(this.id);
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result +
					((id == null) ? 0 : id.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (!(obj instanceof GenericId))
			return false;
		final GenericId other = (GenericId) obj;
		if (id == null) {
			if (other.id != null)
				return false;
		} else if (!id.equals(other.id))
			return false;
		return true;
	}

}