package muskel.mdf;
/**
 * Un input Token contentente un task e un bit di presenza.
 * La differenza rispetto ad un Token è puramente logica.
 * 
 * @author albanese
 * */
public class InputToken extends Token {

	private static final long serialVersionUID = -1867553850460846344L;

	/**
	 * Creates a input token with a given value
	 * @param task the value to be stored in the input token
	 */
	public InputToken(Task task) {
		super(task);
	}
	
	/** 
	 * This is to create an empty input token, just a placeholder
	 */
	public InputToken()	{
		super();
	}
	
	/** 
	 * This is to store a task in an empty input token
	 * or in an already setup token
	 * @param task the new task for the input token
	 */
	public void updateInputToken(Task task) {
		super.updateToken(task);
	}
	
	public String toString() {
		return super.toString();
	}
	
	public Object clone() {
		
		Task clonedTask = 
			(task == null) ? null : (Task) task.clone();
		
		InputToken clone = new InputToken();
		clone.task = clonedTask;
		clone.presenceBit = this.presenceBit;
		
		return clone;
	}
}
