package muskel.mdf;

/**
 * A simple Integer Identifier Generator Implementation.
 * Generates a new, progressive, Integer id.
 * */
public class IntegerIdGenerator implements IdGenerator {

	private static final long serialVersionUID = 453779581267041580L;
	
	private static int nextId = 0;
	private static final int NO_ID = -1;
	
	private static final IntegerIdentifier NOID = new IntegerIdentifier(NO_ID);
	
	/**
	 * Generates a new Integer id.
	 * 
	 * @return A new Integer id
	 * */
	public IntegerIdentifier generateId() {
		
		return new IntegerIdentifier(nextId++);
	}

	/**
	 * Returns the NoId special Integer Identifier.
	 * 
	 * @return The NoId special Integer Identifier.
	 * */
	public static IntegerIdentifier getNoId() {
		return NOID;
	}
}
