package muskel.mdf;

public class IntegerIdentifier implements Identifier {

	private static final long serialVersionUID = 1370223080233032298L;
	
	private Integer intId;

	public IntegerIdentifier(Integer id) {
		this.intId = id;
	}
	
	public Integer getId() {
		return intId;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((intId == null) ? 0 : intId.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object id) {
		if (this == id)
			return true;
		if (id == null)
			return false;
		if (!(id instanceof IntegerIdentifier))
			return false;
		final IntegerIdentifier other = (IntegerIdentifier) id;
		if (intId == null) {
			if (other.intId != null)
				return false;
		} else if (!intId.equals(other.intId))
			return false;
		return true;
	}

	public int compareTo(Identifier arg0) {
		
		IntegerIdentifier arg = (IntegerIdentifier) arg0;
		
		return intId.compareTo(arg.getId());
	}

	public String toString()
	{
		return intId.toString();
	}
}
