package muskel.mdf;

/**
 * This is the class hosting a destination token,
 * as output from a MDF instruction.
 * It's a token with destination address embedded in.
 * 
 * @author marcod
 *
 */
public class OutputToken extends Token implements Cloneable {
	
	private static final long serialVersionUID = 4563691392373961077L;
	
	private Destination dest;
	
	/**
	 * Crea un OutputToken con task e destination specificati
	 * Il bit di presenza del token e' a true;
	 * 
	 * */
	public OutputToken(Task t, Destination d) {
		super(t);
		dest = d;
	}
	
	/**
	 * Crea un OutputToken con destination specificato
	 * Il bit di presenza del token e' a false e il task e' null
	 * 
	 * */
	public OutputToken(Destination d) {
		
		super();	
		dest = d;
	}
	
	public void setDest(Destination dest) {
		this.dest = dest;
	}
	
	public String toString() {
		
		return super.toString() + " " + dest;
	}
	
	/**
	 * deep copy
	 * */
	public Object clone() {
	
		Destination clonedDest =
				(this.dest == null) ? null : (Destination) this.dest.clone();
		
		OutputToken clone = new OutputToken(clonedDest);
		
		clone.task = (this.task == null) ? null : (Task) this.task.clone();
		
		clone.presenceBit = this.presenceBit;	
		
		return clone;
	}

	public Destination getDestination() {
		return dest;
		
	}
}
