package muskel.mdf;

/**
 * SEComputeResult ospita sia il risultato prodotto dal metodo compute di Mdfi,
 * cioe' un vettore di {@link OutputToken},
 * sia un vettore di nuovi {@link Task} prodotti dalla Mdfi stessa.
 * */
public class SEComputeResult extends ComputeResult {

	private static final long serialVersionUID = -3959544943968671714L;
	
	private Task[] generatedTasks;
	
	/**
	 * Crea un nuovo SEComputeResult contenente il vettore di
	 * {@link OutputToken} e quello di {@link Task} specificati
	 * */
	public SEComputeResult(OutputToken[] outTok, Task[] generatedTasks)
	{
		super(outTok);
		this.generatedTasks = generatedTasks;	
	}

	/**
	 * Restituisce il vettore di {@link Task} contenuto in this.
	 * Esso puo' essere null.
	 * */
	public Task[] getGeneratedTasks() {
		return generatedTasks;
	}
	
}
