package muskel.stream;
/**
 * Interfaccia degli gli InputManager che forniscono metodi
 * next e hasNext bloccanti e permettono agli
 * SECompute di aggiungere task.
 * */
public interface BlockingInputManager extends InputManager {

	/**
	 * Aggiunge task allo stream
	 * */
	public void addTask(Object task);
	
	
	/**
	 * Segnala allo stream la presenza di numSECompute potenziali nuovi produttori
	 * */
	public void addProducers(int numSECompute);
	
	/**
	 * Segnala allo stream la presenza di un potenziale nuovo produttore
	 * */
	public void addProducer();
	
	/**
	 * Segnala allo stream che un produttore ha smesso di produrre
	 * */
	public void removeProducer();
}
