/* This is the muskel: a skeleton/RMI based, parallel programming library
Copyright (C) 2006  Marco Danelutto, Dept. Computer Science, Univ. Pisa, Italy

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */

package muskel.stream;

import org.apache.log4j.Logger;

/**
 * This is used to deliver output tokens to the user Console
 * toString() is used to print the items.
 * 
 * @author marcod
 *
 */
public class ConsoleOutputManager implements muskel.stream.OutputManager {

   
	Logger log = Logger.getLogger(ConsoleOutputManager.class.getName());
	
	/**
	 * this is the method actually delivering
	 * the output token onto the user console,
	 * using a println and converting the object to a string 
	 * with a call to toString() method.
	 * @param result the result token
	 * 
	 */
    public void deliver(Object result) {
    	log.debug("Delivering task: result");
	System.out.println(result.toString());
    }
}
