/* This is the muskel: a skeleton/RMI based, parallel programming library
Copyright (C) 2006  Marco Danelutto, Dept. Computer Science, Univ. Pisa, Italy

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */

package muskel.stream;

/**
 * this is the interface that must be implemented 
 * to supply the class providing the program input stream
 *
 * @author marcod
 *
 */
public interface InputManager {
	
    /**
     * this is the metod used by the manager to get
     * the next task to compute, if any. In case there is no more tasks,
     * a null is returned as the EndOfStream mark
     *  @return null if there is no more tasks, the task to be computed otherwise
     */

    public Object next();

    /** this is the method used to check whether there are other tasks
     * available onto the input stream
     *  @return true is there is at least one more task, false otherwise
     */
    public boolean hasNext();

}
