/* This is the muskel: a skeleton/RMI based, parallel programming library
Copyright (C) 2006  Marco Danelutto, Dept. Computer Science, Univ. Pisa, Italy

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */

package muskel.stream;

/**
 * this is the interface implemented to provide
 * the class post processing the results computed
 * by the skeleton program
 *
 * @author marcod
 */
public interface OutputManager {

    /**
     * this is the method used to deliver a result
     * by the program manager<br>
     * Users must supply an actual deliver method to properly handle the 
     * current result
     */ 
    public void deliver(Object result);
	
}
