/* This is the muskel: a skeleton/RMI based, parallel programming library
Copyright (C) 2006  Marco Danelutto, Dept. Computer Science, Univ. Pisa, Italy

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. */

/*
 * Created on Mar 22, 2004
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package skeleton;

import muskel.mdf.Task;

/**
 * This is the "emabarassingly parallel" skeleton.
 * Each task supplied to the Farm is actually computed 
 * independently of the other tasks by invoking the compute
 * method of the inner skeleton (alias the worker).
 * <br>
 * 
 * @author Danelutto Marco
 *
 */
public class Farm extends Compute {
	
	private static final long serialVersionUID = 1L;
	Compute worker = null;
	
	/**
	 * creates a new Farm skeleton.
	 * @param worker is the skeleton used to implement the Farm 
	 * workers, i.e. it is the skeleton modelling the computation
	 * that has to be independently performed on each one of
	 * the tasks submitted to the Farm.
	 */
	public Farm(Compute worker) {
		this.worker = worker;
	}
	
	/**
	 * This is only needed to compiler into MDF 
	 * 
	 * @return the worker code
	 */
	public Compute getWorker() {
		return worker;
	}
	/**
	 * computes a task sequentially.
	 * @param task the input data to be processed
	 * @return the result of the computation, as an Objects
	 */
	public Task[] compute(Task[] task) {
		return worker.compute(task);
	}
}
